
;triangle_shd:
;-  Procedure draws horizontal line - saturated substraction in
;-  every pixel ------------------------------------------------
;-  First stage sorting coord, calc deltas, two calling loops --
;-  - see  3stencil.inc file...

;----------------------------------------------------
;-------------in xmm0 - lo -> hi z1, z2 -------------
;--------------- xmm5 - lo -> hi y_min, y_max, x_min,
;- -------------	x_max -----------------------
;--------------- eax - x1 ---------------------------
;--------------- ebx - x2 ---------------------------
;--------------- ecx - y-----------------------------
;--------------- edx - x_res shl 16 + y_res ---------
;--------------- esi - pointer to z-buffer ----------
;--------------- edi - pointer to screen buffer------
;--------------- esi - shadow buffer ----------------

shadow_line:

.xmax	equ [ebp-4]
.xmin	equ [ebp-8]
.ymax	equ [ebp-12]
.ymin	equ [ebp-16]
.xres	equ word[ebp-18]
.yres	equ word[ebp-20]
.x1	equ [ebp-24]
.x2	equ [ebp-28]

     push	ebp
     mov	ebp,esp
     sub	esp,16
     movups	.ymin,xmm5
     push	edx
     cmp	ecx,.ymin
     jle	.l_quit

     cmp	ecx,.ymax  ;.y_res
     jge	.l_quit

     cmp	eax,ebx
     je 	.l_quit
     jl 	.l_ok

     xchg	eax,ebx

  .l_ok:

     cmp	eax,.xmax
     jge	.l_quit
     cmp	ebx,.xmin
     jle	.l_quit

     cmp	eax,.xmin
     cmovb	eax,.xmin
     cmp	ebx,.xmax
     cmova	ebx,.xmax

     push	eax
     push	ebx

     movzx	edx,.xres
;     movzx	 edx,[xres_var]
     mov	eax,ecx
     mul	edx		     ; edi = edi + (SIZE_X * y + x1)*4
     add	eax,.x1
     add	esi,eax
     shl	eax,2
     add	edi,eax

     mov	ecx,ebx ;.x2
     sub	ecx,.x1

     mov	eax,0x00444444
     movd	xmm0,eax  ;.col
     
   ;  pshufd	 xmm0,xmm0,0
   ;  shr	 ecx,1
   ;  jnc	 @f
   ;  movd	 xmm1,[edi]
   ;  psubusb	 xmm1,xmm0
   ;  movd	 [edi],xmm1
   ;  add	  edi,4
   ;  jecxz	 .fl_quit
   .ddraw:
     cmp       byte[esi],0
     jne       @f
     movd      xmm1,[edi]
     psubusb   xmm1,xmm0
     movd      [edi],xmm1
     mov       byte[esi],1
    @@:
     add       edi,4
     inc       esi
     loop     .ddraw

   .l_quit:

     mov   esp,ebp
     pop   ebp
ret
